import processing.serial.*;

Serial myPort;  // Create object from Serial class
char val;     // Data received from the serial port 

float bx;
float by;
int boxSize = 75;
boolean overBox = false;
boolean locked = false;
float xOffset = 0.0; 
float yOffset = 0.0; 
color bg_color = color(204, 153, 0); 


void setup() 
{
// List all the available serial ports:
  println(Serial.list());
  // Open the port you are using at the rate you want:
  myPort = new Serial(this, "/dev/ttyUSB0", 9600);
  
  size(640, 360);
  bx = width/2.0;
  by = height/2.0;
  rectMode(RADIUS); 
  background(205,55,55);

}



void draw() 
{ 
  background(bg_color);
  
  if (myPort.available () > 0) {
    //set the variable height equal to the data comming in.
    int button = myPort.read(); 
    println(button);  //print the values read from the serial port to the console
    
    if (button == 'x') {
          //currently draws random background for the full range of color
    bg_color = color(random(255), random(255), random(255));
    }
   
  }

  
  // Test if the cursor is over the box 
  if (mouseX > bx-boxSize && mouseX < bx+boxSize && 
      mouseY > by-boxSize && mouseY < by+boxSize) {
    overBox = true;  
    if(!locked) { 
      strokeWeight(5);
      stroke(255); 
      fill(123);
    } 
  } else {
    strokeWeight(5);
    stroke(103);
    fill(180);
    overBox = false;
  }
  
  // Draw the box
    rect(bx, by, boxSize, boxSize);

}


void mousePressed() {
  if(overBox) { 
    locked = true; 
    fill(255, 255, 255);
    stroke(0);
    myPort.write('c');              // send an c to indicate user is clicking the square
  } else {
    locked = false;
  }
  xOffset = mouseX-bx; 
  yOffset = mouseY-by; 

}

void mouseReleased() {
  locked = false;
}

void mouseDragged() {
  if(locked) {
    bx = mouseX-xOffset; 
    by = mouseY-yOffset; 
    
  }

}



